module Lagerverwaltung where

import Numeric.Natural

-- Die Objekte die gelagert werden sollen, mit ihrer Anzahl
data Artikel a = A a Natural

instance Eq a => Eq (Artikel a) where
   A a1 _ == A a2 _ = a1 == a2
  
instance Show a => Show (Artikel a) where 
   show (A a n) = show a ++ ": "++ show n

-- Unser Lager
type Lager a = [Artikel a]

-- Ein Produkt, dass sich aus bestimmten Teilen zusammensetzt
data Produkt a b = P {name:: b, zutaten:: [Artikel a]}

instance Eq b => Eq (Produkt a b) where
   P b1 _ == P b2 _ = b1 == b2
    
instance (Show a, Show b) => Show (Produkt a b) where
   show (P b as) = show b++ ": "++ show as

enthaelt :: Eq a => Lager a -> a -> Natural
enthaelt = undefined

hinzufuegen :: Eq a => Lager a -> a -> Natural -> Lager a
hinzufuegen = undefined

entfernen :: Eq a => Lager a -> a -> Natural -> Lager a
entfernen = undefined
    
teileVorhanden :: (Eq a, Eq b) => Produkt a b -> Lager a -> Bool
teileVorhanden = undefined

entferneProdukt :: (Eq a, Eq b) => Produkt a b -> Lager a -> Lager a
entferneProdukt = undefined

produzieren :: (Eq a, Eq b) => [Produkt a b] -> Lager a -> Lager a
produzieren = undefined
